
#include "stdafx.h"
#include "Regsvr32UI.h"
#include "Regsvr32UIDlg.h"
#include "comcat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)

END_MESSAGE_MAP()

CRegsvr32UIDlg::CRegsvr32UIDlg(CWnd* pParent)
	: CDialog(CRegsvr32UIDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON2);
	m_Name = "";
	m_Path = "";
}

void CRegsvr32UIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST2, m_list2);
	DDX_Text(pDX, IDC_EDIT1, m_Name);
	DDX_Text(pDX, IDC_EDIT2, m_Path);
}

BEGIN_MESSAGE_MAP(CRegsvr32UIDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST2, OnItemchangedList1)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
END_MESSAGE_MAP()

BOOL CRegsvr32UIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_list2.ModifyStyle(LVS_ICON, LVS_REPORT | LVS_SORTASCENDING);
	m_list2.InsertColumn(0, _T("ActiveX Control"),LVCFMT_LEFT,350);
	m_list2.InsertColumn(1, _T("Path"),LVCFMT_LEFT,550);
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);
	RefreshList();
	return TRUE;  
}

void CRegsvr32UIDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	POSITION p = m_list2.GetFirstSelectedItemPosition();
	while (p)
	{
		int nSelected = m_list2.GetNextSelectedItem(p);
		TCHAR szBuffer[1024];
		DWORD cchBuf(1024);
		LVITEM lvi;
		lvi.iItem = nSelected;
		lvi.iSubItem = 0;
		lvi.mask = LVIF_TEXT;
		lvi.pszText = szBuffer;
		lvi.cchTextMax = cchBuf;
		m_list2.GetItem(&lvi);
		m_Name =lvi.pszText;
		lvi.iItem = nSelected;
		lvi.iSubItem = 1;
		lvi.mask = LVIF_TEXT;
		lvi.pszText = szBuffer;
		lvi.cchTextMax = cchBuf;
		m_list2.GetItem(&lvi);
		m_Path =lvi.pszText;
	}
	UpdateData(FALSE);
	*pResult = 0;
}






void CRegsvr32UIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CRegsvr32UIDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CRegsvr32UIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRegsvr32UIDlg::OnButton1() 
{
	CString sParameters = _T(" /u /s \"") + m_Path + _T("\"");
	::std::wstring wParameters(sParameters.GetString());
	CString sExec = getenv("WINDIR");
	sExec = sExec + _T("\\System32\\regsvr32.exe");
	::std::wstring wExec(sExec.GetString());
	ExecuteProcess(wExec, wParameters, 10000);
	m_list2.DeleteAllItems();
	RefreshList();
	m_Name = _T("");
	m_Path = _T("");
	UpdateData(FALSE);
}

void CRegsvr32UIDlg::OnButton2() 
{
	m_list2.DeleteAllItems();
	RefreshList();
}

void CRegsvr32UIDlg::OnButton3()
{ 
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, _T("ActiveX Controls(*.ocx;*.dll)|*.ocx;*.dll||"),this);
	fileDlg.m_ofn.lpstrTitle = _T("Register ActiveX Control");
	if ( fileDlg.DoModal() == IDOK)
	{
		CString sFile = _T(" /s \"") +  fileDlg.GetPathName() + _T("\"");
		::std::wstring wFile(sFile.GetString());
		CString sExec = getenv("WINDIR");
		sExec = sExec + _T("\\System32\\regsvr32.exe");
		::std::wstring wExec(sExec.GetString());
		ExecuteProcess(wExec, wFile, 10000);
		m_list2.DeleteAllItems();
		RefreshList();
	}
}

size_t ExecuteProcess(std::wstring FullPathToExe, std::wstring Parameters, size_t SecondsToWait) 
{ 
    size_t iMyCounter = 0, iReturnVal = 0, iPos = 0; 
    DWORD dwExitCode = 0; 
    std::wstring sTempStr = L""; 
    if (Parameters.size() != 0) 
    { 
        if (Parameters[0] != L' ') 
        { 
            Parameters.insert(0,L" "); 
        } 
    } 
    sTempStr = FullPathToExe; 
    iPos = sTempStr.find_last_of(L"\\"); 
    sTempStr.erase(0, iPos +1); 
    Parameters = sTempStr.append(Parameters); 
    wchar_t * pwszParam = new wchar_t[Parameters.size() + 1]; 
    if (pwszParam == 0) 
    { 
        return 1; 
    } 
    const wchar_t* pchrTemp = Parameters.c_str(); 
    wcscpy(pwszParam, pchrTemp);
    STARTUPINFOW siStartupInfo; 
    PROCESS_INFORMATION piProcessInfo; 
    memset(&siStartupInfo, 0, sizeof(siStartupInfo)); 
    memset(&piProcessInfo, 0, sizeof(piProcessInfo)); 
    siStartupInfo.cb = sizeof(siStartupInfo); 

    if (CreateProcessW(const_cast<LPCWSTR>(FullPathToExe.c_str()), 
                            pwszParam, 0, 0, false, 
                            CREATE_DEFAULT_ERROR_MODE, 0, 0, 
                            &siStartupInfo, &piProcessInfo) != false) 
    { 
        dwExitCode = WaitForSingleObject(piProcessInfo.hProcess, (SecondsToWait * 1000)); 
    } 
    else 
    { 
        iReturnVal = GetLastError(); 
    } 
    delete[]pwszParam; 
    pwszParam = 0; 
    CloseHandle(piProcessInfo.hProcess); 
    CloseHandle(piProcessInfo.hThread); 
    return iReturnVal; 
}  
  




void CRegsvr32UIDlg::RefreshList(void)
{
	CoInitialize (NULL);
	ICatInformation *pCatInfo=NULL;
	HRESULT hr=CoCreateInstance (CLSID_StdComponentCategoriesMgr ,NULL,CLSCTX_INPROC_SERVER,IID_ICatInformation ,(void **)&pCatInfo);
	pCatInfo->AddRef ();
	IEnumGUID *pEnumGUID=NULL;
	CATID pcatidImpl[1];
	CATID pcatidReqd[1];
	pcatidImpl[0]=CATID_Control;
	pCatInfo->EnumClassesOfCategories (1,pcatidImpl,0,pcatidReqd ,&pEnumGUID);
	CLSID clsid;
	int i = 0;
	while( (hr= pEnumGUID->Next( 1, &clsid, NULL ))==S_OK )
	{
		BSTR bstrClassName;
		OleRegGetUserType (clsid,USERCLASSTYPE_FULL,&bstrClassName);
		CString strControlName(bstrClassName);
		LPOLESTR className;
		hr = StringFromCLSID(clsid, &className);
		CString sCLSID = className;
		CoTaskMemFree(className);
		CString sPath = "";
		HKEY hKey;
		if (RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("CLSID\\" + sCLSID + "\\InprocServer32"), 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS)
		{
				TCHAR strValue[255] = _T("");
				DWORD dwBufLen = 255;
				RegQueryValueEx(hKey, NULL, NULL, NULL, (LPBYTE) strValue, &dwBufLen);
				RegCloseKey(hKey);
				TCHAR strLongPath[1500] = _T("");
				dwBufLen = 1500;
				GetLongPathName(strValue, strLongPath, dwBufLen);
				sPath = strLongPath;
		}
		LVITEM lvi;
		lvi.mask = LVIF_TEXT;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = (LPTSTR)(LPCTSTR)strControlName;
		int j;
		j = m_list2.InsertItem(&lvi);
		lvi.iItem = j;
		lvi.iSubItem = 1;
		lvi.pszText = (LPTSTR)(LPCTSTR)sPath;
		m_list2.SetItem(&lvi);
		i = i + 1;
	}	
	pCatInfo->Release ();
	CoUninitialize ();
}
