
#include "stdafx.h"
#include "ListOfAllControls.h"
#include "ListOfAllControlsDlg.h"
#include "comcat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListOfAllControlsDlg dialog

CListOfAllControlsDlg::CListOfAllControlsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListOfAllControlsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListOfAllControlsDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListOfAllControlsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListOfAllControlsDlg)
	DDX_Control(pDX, IDC_LIST1, m_list1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CListOfAllControlsDlg, CDialog)
	//{{AFX_MSG_MAP(CListOfAllControlsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListOfAllControlsDlg message handlers

BOOL CListOfAllControlsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	

	
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		
	
	
	//Initialise com libraries
	CoInitialize (NULL);

	//The Component Category Manager implemented by System
	//implements this interface
	ICatInformation *pCatInfo=NULL;
	
	//Create an instance of standard Component Category Manager
	HRESULT hr=CoCreateInstance (CLSID_StdComponentCategoriesMgr ,NULL,CLSCTX_INPROC_SERVER,IID_ICatInformation ,(void **)&pCatInfo);

	//Increase ref count on interface
	pCatInfo->AddRef ();

	//IEnumGUID interface provides enumerator for
	//enumerating through the collection of com objects
	IEnumGUID *pEnumGUID=NULL;

	//We are intersted in finding out only controls
	//so put CATID_Control in the array
	CATID pcatidImpl[1];
	CATID pcatidReqd[1];
	pcatidImpl[0]=CATID_Control;

	//Now enumerate the classes i.e. com objects of this type.
	pCatInfo->EnumClassesOfCategories (1,pcatidImpl,0,pcatidReqd ,&pEnumGUID);
	
	//Enumerate as long as you get S_OK
	CLSID clsid;
	while( (hr= pEnumGUID->Next( 1, &clsid, NULL ))==S_OK )
	{
		BSTR bstrClassName;	
	    

		//Get the information of class
		//This is what MSDN says about the parameters
		/*-----------------------------------------------
		USERCLASSTYPE_FULL     The full type name of the class. 
		USERCLASSTYPE_SHORT    A short name (maximum of 15 characters) that is used for popup menus and the Links dialog box. 
		USERCLASSTYPE_APPNAME  The name of the application servicing the class and is used in the Result text in dialog boxes. 
		-----------------------------------------------*/
		OleRegGetUserType (clsid,USERCLASSTYPE_FULL,&bstrClassName);
		CString strControlName(bstrClassName);
		//Add string in our listbox
		m_list1.AddString (strControlName);
	}	

	//we are done so now release the interface ptr
	pCatInfo->Release ();

	CoUninitialize ();
	
	return TRUE;  
}

void CListOfAllControlsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListOfAllControlsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CListOfAllControlsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

